{ PLEASE, READ THIS IMPORTANT INFORMATION FIRST.
  Class Tapptime,  Benot Standaert, 2001.
  Tapptime is a component derived from the class TLabel.
  It uses a timer. It gives you in real time
  the Application's running time, rate of refreshment : every second.
  The application's running time is given via
  the property caption of the component.
  A boolean property called ACTIVE is set by defaut on True.
  If you set this property on false the refreshment is stopped.
  Four more properties are also new, all of them giving you a STRING result :
        - HOUR   : result is how many hours the application is running,
        - MINUTE : like HOUR but for the minute,
        - SECOND : like HOUR but for the second.
        - COPYRIGHT : hey, I did this component after all.

  I hate this but here is a disclaimer.

  DISCLAIMER :
  This component is FREEWARE but it is still the property of it's author :
   Benot Standaert, 2001.
  You use this component AT YOUR OWN RISK. I wont be responsible for
  any kind of problem you might encounter. This component is given AS IS.
  If you do not agree with this disclaimer YOU CANNOT INSTALL THIS COMPONENT
  AND ALSO YOU CANNOT USE IT.

  Please, report any bugs and or comments to this Email : tactictoe@yahoo.fr
  I would also appreciate notification of any improvements or/and modification
  you might make to this component!
  }
unit Apptime;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TApptime = class(TLabel)
  private
    { Private declarations }
    Tempo : Ttimer;
    n, hou, min, sec : string;
    s, m, h : integer;
  protected
    { Protected declarations }
    FHour       : String;
    FMinute     : String;
    FSecond     : String;
    Fcopyright  : string;
    FActive     : boolean;
  public
    { Public declarations }
    constructor create (aowner: tcomponent); override;
    destructor destroy; override;
    procedure  newtime (Sender: Tobject);
  published
    { Published declarations }
    property Hour:String        read FHour      write Fhour;
    property Minute:String      read FMinute    write FMinute;
    property Second:String      read FSecond    write FSecond;
    property Copyright:String   read fcopyright;
    property Active:boolean     read FActive    Write FActive;
  end;

procedure Register;

implementation

constructor TApptime.create;
 begin
 s := 0;
 m := 0;
 h := 0;
 FActive := true;
 inherited create (Aowner);

 Tempo := Ttimer.create (self);

  with Tempo do begin
   enabled      := true;
   Interval     := 1000;
   ontimer      := newtime;
  end;
 fcopyright := ' Benot Standaert, 2001';
end;

destructor TApptime.destroy;
 begin
 Tempo.destroy;
 Inherited destroy;
 end;

procedure TApptime.newtime (Sender: TObject);
 var
 Sbck, Mbck, HBck : integer;
 begin
 SBck := s;
 MBck := m;
 HBck := h;
 inc (s);
 if s = 60 then begin
  s := 0;
  inc (m);
  end;
 if m = 60 then begin
  m := 0;
  inc (h);
  end;
 if Factive = false then
  begin
  s := Sbck;
  m := Mbck;
  h := Hbck;
  end;
 if h < 10 then begin
  hou := '0' + inttostr (h) + ':';
  FHour := '0' + inttostr (h);
  end
 else begin
  hou := inttostr (h) + ':';
  FHour := inttostr (h);
  end;
 if m < 10 then begin
  min := '0' + inttostr (m) + ':';
  FMinute := '0' + inttostr (m);
  end
 else begin
  min := inttostr (m) + ':';
  FMinute := inttostr (m);
  end;
 if s < 10 then begin
  sec := '0' + inttostr (s);
  FSecond := '0' + inttostr (s);
  end
 else begin
  sec := inttostr (s);
  FSecond := inttostr (s);
  end;
 n := hou + min + sec;
 caption := n;
 end;

procedure Register;
begin
  RegisterComponents('Benoit Standaert', [TApptime]);
end;

end.
